# Generated by Django 2.0.5 on 2020-06-05 10:59

from django.db import migrations


class Migration(migrations.Migration):

    def restructure_columns_data(apps, schema_editor):

        def _remove_empty_keys(data):
            return {k: v for k, v in data.items() if v is not None}

        DeviceInfo = apps.get_model("core", "DeviceInfo")

        device_monitoring_data_keys = [
            "device_id",
            "device_datasource_id",
            "device_datasource_instance_id",
        ]
        _config = {
            "config_id": "",
            "device_id": "",
            "config_display_name": "",
            "config_datasource_id": "",
            "config_instance_name": "",
            "config_datasource_name": "",
            "config_datasource_instance_id": "",
            "config_datasource_instance_name": "",
        }
        config_meta_data_keys = list(_config.keys())
        sw_monitoring_meta_keys = ["node_id", "collector_id"]

        for record in DeviceInfo.objects.all():
            lm_monitoring_meta_data = {}
            sw_monitoring_meta_data = {}
            lm_config_meta_data = {}
            for k in device_monitoring_data_keys:
                lm_monitoring_meta_data.update({k: record.config_meta_data.get(k)})

            for k in sw_monitoring_meta_keys:
                sw_monitoring_meta_data.update({k: record.config_meta_data.get(k)})

            for k in config_meta_data_keys:
                lm_config_meta_data.update({k: record.config_meta_data.get(k)})

            lm_monitoring_meta_data = _remove_empty_keys(lm_monitoring_meta_data)
            sw_monitoring_meta_data = _remove_empty_keys(sw_monitoring_meta_data)
            lm_config_meta_data = _remove_empty_keys(lm_config_meta_data)
            LOGICMONITOR = "logicmonitor"
            SOLARWINDS = "solarwinds"
            record.monitoring_meta_data = {
                LOGICMONITOR: lm_monitoring_meta_data,
                SOLARWINDS: sw_monitoring_meta_data,
            }
            record.config_meta_data = {LOGICMONITOR: lm_config_meta_data}
            record.configuration = {LOGICMONITOR: record.configuration}
            record.save()

    dependencies = [("core", "0063_auto_20200604_1016")]

    operations = [
        migrations.RunPython(restructure_columns_data)
    ]
